<template>
  <div>
    <div class="text-container" :style="{height:height,width:width}">
      <ul class="allDemeanor" @mouseover="handleMouseOver" @mouseleave="handleMouseLeave">
        <li v-for="(item,index) in demeanorList" class="info">
          <span style="padding-left: 20px; display: inline-block; width: 20%;">{{parseTime(item.date, '{yyyy}-{mm}-{dd}')}}</span>
          <span style="padding-left: 20px; display: inline-block; width: 80%;" id="demeanor-title" @click="handleSee(item.url)">{{item.title}}</span>
        </li>
      </ul>
    </div>
  </div>
</template>

<script scoped>
  import { listDemeanorNoPage } from "@/api/branch/demeanor";

  const totalDuration = 2000;

  export default {
    name: "DemeanorChart",
    props: {
      width: {
        type: String,
        default: '100%'
      },
      height: {
        type: String,
        default: '300px'
      }
    },
    data() {
      return {
        // 查询参数
        queryParams: {},
        // 先进风采列表
        demeanorList: null,
      }
    },
    created() {
      this.listDemeanorNoPage();
    },
    methods: {
      handleMouseOver() {
        let elem = document.querySelector('.allDemeanor');
        elem.style['animation-play-state'] = 'paused';
      },
      handleMouseLeave() {
        let elem = document.querySelector('.allDemeanor');
        elem.style['animation-play-state'] = 'running';
      },
      handleSee(url) {
        window.open(process.env.VUE_APP_BASE_API + url);
      },
      /** 查询先进风采列表 */
      listDemeanorNoPage() {
        this.queryParams.isPinned = 1;
        listDemeanorNoPage(this.queryParams).then(response => {
          this.demeanorList = response.data;
          //判断是否需要滚动
          if (this.demeanorList.length > 4) {
            //设置文字滚动一轮时间
            let elem = document.querySelector('.allDemeanor');
            let state = elem.style['animation'];
            let time = this.demeanorList.length * 2
            elem.style['animation'] = 'myMove ' + time + 's linear infinite';
            let state1 = elem.style['animation-fill-mode'];
            elem.style['animation-fill-mode'] = 'forwards';
            //设置文字无缝滚动高度
            let param = this.demeanorList.length * 50
            let myFirstkeyframes = "@keyframes myMove{0% {transform: translateY(200px);}100% {transform: translateY(-" + param +"px);}}";
            let style = document.createElement("style");
            style.setAttribute("type", "text/css");
            document.head.appendChild(style);
            const sheet = style.sheet;
            sheet.insertRule(myFirstkeyframes, 0);
          }
        });
      },
    }
  }
</script>

<style scoped>
  #demeanor-title {
    padding-left: 20px;
  }

  #demeanor-title:hover {
    cursor: pointer;
  }

  .text-container {
    line-height: 30px;
    overflow: hidden;
    background-color: rgba(255, 255, 255, 0.6);
    padding-top: 10px;
  }

  .dangao {
    width: 40px !important;
    height: 40px !important;
  }

  .info {
    font-weight:bold;
    list-style: none;
    display: flex;
    margin: 10px 0 0 0;
    align-items: center;     /* 垂直居中 */
    border-radius:5px 5px 5px 5px ;
    /*border: 2px solid rgba(41, 107, 155, 0.71);*/
    background-color: transparent;
    border-bottom: 1px dashed #C0C0C0;
  }

  .allDemeanor {
    margin: -10px 0 0 0;
    padding: 0 20px 0 20px;
    /*animation: myMove 10s linear infinite;
    animation-fill-mode: forwards;*/
  }

  /*文字无缝滚动*/
  /*@keyframes myMove {
    0% {
      transform: translateY(200px);
    }
    100% {
      transform: translateY(-300px);
    }
  }*/

  /*文字停顿滚动*/
  @keyframes myMove2 {
    0% {
      transform: translateY(0);
    }
    10% {
      transform: translateY(-30px);
    }
    20% {
      transform: translateY(-30px);
    }
    30% {
      transform: translateY(-60px);
    }
    40% {
      transform: translateY(-60px);
    }
    50% {
      transform: translateY(-90px);
    }
    60% {
      transform: translateY(-90px);
    }
    70% {
      transform: translateY(-120px);
    }
    80% {
      transform: translateY(-120px);
    }
    90% {
      transform: translateY(-150px);
    }
    100% {
      transform: translateY(-150px);
    }
  }

  .info span {
    padding-top: 5px;
  }
</style>
